<script lang="ts">
import Vue from 'vue';
import { toKebabCase } from '@/lib/utils';

export default Vue.extend({
  name: 'FAQAccordion',
  props: {
    data: {
      required: true,
      type: Object,
    },
    itemIndex: {
      type: Number,
      required: true,
    },
    title: {
      type: String,
      required: false,
      default: '',
    },
  },
  computed: {
    accordionID() {
      return toKebabCase(this.data.header);
    },
  },
  methods: {
    toggleAccordion() {
      this.$emit('toggleController');
    },
    beforeEnter(el) {
      el.style.height = '0';
    },
    enter(el) {
      el.style.height = `${el.scrollHeight + 32}px`;
    },
    beforeLeave(el) {
      el.style.height = `${el.scrollHeight + 32}px`;
    },
    leave(el) {
      el.style.height = '0';
    },
  },
});
</script>

<template>
  <div
    :id="data.headerAnchorId ? data.headerAnchorId : accordionID"
    class="faq-accordion"
  >
    <SlpTypography tag="h5" variant="heading5" class="faq-accordion__summary">
      <button
        :id="data.headerAnchorId ? data.headerAnchorId : `${accordionID}-id`"
        class="faq-accordion__summary__button"
        :aria-expanded="data.expanded"
        :aria-controls="
          data.headerAnchorId ? data.headerAnchorId : `${accordionID}-section`
        "
        :data-ga-toggle="data.expanded ? 'collapse' : 'expand'"
        :data-toggle-group="title"
        :data-inbound-analytics="
          data.dataInboundAnalytics || 'pricing-leap-target'
        "
        @click="toggleAccordion"
      >
        <span class="faq-accordion__summary__text">
          <span class="accordion__header">{{ data.header }}</span>
        </span>
        <span
          class="faq-accordion__icon"
          :class="{ 'faq-accordion__icon--open': data.expanded }"
        ></span>
      </button>
    </SlpTypography>
    <transition
      name="accordion"
      @before-enter="beforeEnter"
      @enter="enter"
      @before-leave="beforeLeave"
      @leave="leave"
    >
      <div
        v-show="data.expanded"
        :id="
          data.headerAnchorId ? data.headerAnchorId : `${accordionID}-section`
        "
        class="faq-accordion__container"
        role="region"
        :aria-labelledby="
          data.headerAnchorId ? data.headerAnchorId : `${accordionID}-id`
        "
      >
        <div v-if="data.text" class="faq-md" v-html="$md.render(data.text)" />
      </div>
    </transition>
  </div>
</template>

<style scoped lang="scss">
.faq-accordion {
  color: $color-text-300;
  list-style-type: none;
  overflow: hidden;
  width: 100%;
  text-align: left;

  &__container {
    transition: 0.3s ease-out;
  }

  &__summary {
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding-top: $spacing-16;
    padding-bottom: 20px;
    border-top: 1px solid $color-surface-300;

    &__button {
      border: 0;
      cursor: pointer;
      display: flex;
      justify-content: space-between;
      padding: 0;
      width: 100%;
      align-items: center;
      font-weight: $font-weight-bold;
      margin-top: $spacing-4;
      color: $color-primary-200;
    }

    &__text {
      display: flex;
      text-align: left;
      max-width: 80%;
    }
  }

  &__copy {
    margin-left: 28px;

    &__text {
      &:deep p {
        margin-bottom: 8px;
      }
    }
  }

  &__link {
    padding: 0;

    &:deep .slp-icon {
      transition: all 0.3s ease-in-out;
    }

    &:hover {
      text-decoration: underline;
    }
  }

  &__icon {
    height: 18px;
    width: 18px;
    position: relative;
    transition: transform 0.4s ease-in-out;
    margin-left: $spacing-4;

    &--open {
      transform: rotate(90deg);

      &:after {
        opacity: 0;
      }
    }

    &:before,
    &:after {
      content: '';
      background-color: black;
      position: absolute;
      display: block;
    }

    &:before {
      height: 18px;
      width: 2px;
      left: 50%;
    }

    &:after {
      height: 18px;
      width: 2px;
      transform: rotate(-90deg);
      top: 50%;
      transform-origin: top;
      transition: opacity 0.3s ease-in-out;
    }
  }
}
</style>
